import Qt 4.7
import Qt.labs.particles 1.0

Item {
    id: textBubble

    property string txt;
    property int xPos
    property int yPos
    property alias imgWidth: imgDeco.width;
    property alias imgHeight: imgDeco.height;

    Image{
        id: imgDeco
        source: "qrc:/images/bubble.svg"
        height: parent.height/4
        width: height*3/2
        //fillMode: Image.PreserveAspectFit
        x: parent.xPos
        y: parent.yPos
    }

    Text {
        id: messageText
        text: txt
        anchors.centerIn: imgDeco
        wrapMode: Text.NoWrap
        color: "white"
        font.family: "Calibri"
        font.pixelSize:  parent.height / 12
        font.bold: true
    }

    SequentialAnimation {
        id:flyBubble
        alwaysRunToEnd: true;
        ParallelAnimation {
            PropertyAnimation { target: textBubble; property: "yPos"; to: textBubble.yPos-30; duration: 2000}
            PropertyAnimation { target: textBubble; property: "opacity"; from: 1; to:0.5; duration: 2000}
            }
        ScriptAction {script: {
                console.log("bubble breaks")
                imgDeco.opacity = 0;
                messageText.opacity =0;
//                var component = Qt.createComponent("Bubblebit.qml");
//                if (component.status == Component.Ready) {
//                    var bubble = component.createObject(textBubble);
//                }
            }
        }
    }

    // ***************************************************
    function explode(text, x,y) {
        txt = text;
        flyBubble.stop();
        xPos = x-imgWidth/2
        yPos = y-imgHeight
        imgDeco.opacity = 1;
        messageText.opacity = 1;
        textBubble.opacity = 1;
        console.log("bubble is at ", imgDeco.x, " ", imgDeco.y);
        flyBubble.restart();
    }
}
