import Qt 4.7;
import Qt.labs.particles 1.0;

Item {
    id:bubbleBreaker
    width: 100;
    height: 100;

    property alias xPos:parent.xPos;
    property alias yPos:parent.yPos;
    property alias imgWidth: parent.imgWidth
    property alias imgHeight: parent.imgHeight

    x: parent.x
    y: parent.y
    z: parent.z+1;

    Particles {
        id: explodeBubble;
        source: "qrc:/images/bubble_bit.svg";
        width: 1; height: 1;
        x: xPos+imgWidth/2; y: yPos+imgHeight/2;


        opacity: 0;

        count: 100;
        angle: 0; angleDeviation: 360;
        velocity: 30; velocityDeviation: 10;
        lifeSpan: 500;
        fadeInDuration: 200;
        ParticleMotionGravity {yattractor: 1000; xattractor: 0; acceleration: 200}
    }
    
    SequentialAnimation {
      id: burstAnim;
      PauseAnimation{duration: 100}
      ScriptAction {script: explodeBubble.count =0}
      PauseAnimation{duration: 1000}
      ScriptAction {script: explodeBubble.opacity =0}
    }
    
    Component.onCompleted: {
      explodeBubble.x = xPos+imgWidth/2;
      explodeBubble.y = yPos+imgHeight/2;
      console.log("bubble burst at ", bubbleBreaker.x, " ", bubbleBreaker.y, "", bubbleBreaker.z)
      explodeBubble.burst(1);
      explodeBubble.opacity = 1;
      burstAnim.start();
    }
}
