/*
* Copyright (c) 2010 Nokia Corporation.
 */

//import Qt 4.7
import Qt 4.7

Item {
    width: main.width/16 //40-50pix depending on the platform
    height: width
    smooth: true

    property string buttonPath // for example "qrc:/gfx/exit.png"
    property int buttonId: 0

    signal btnClicked(int buttonId)


    property bool animationEnabled: true

    Image {
        id: image
        anchors.fill: parent
        source: buttonPath
        fillMode: Image.PreserveAspectFit
        smooth: true
    }

    SequentialAnimation {
        id:anim
        PropertyAction  { target: image; property: "scale"; value:"0.7"}
        PauseAnimation { duration: 200 }
        PropertyAction  { target: image; property: "scale"; value:"1.0"}
    }

    PropertyAnimation { id: animDown; target: image; property: "scale"; to: "0.7"; duration: 200;}
    PropertyAnimation { id: animUp; target: image; property: "scale"; to: "1.0"; duration: 100;}

    Timer {
        id: buttonPressedTimer
        interval: 300; running: false; repeat: false
        onTriggered: btnClicked(buttonId)
    }

    MouseArea {
        anchors.fill: parent
        onPressed: {
            if (animationEnabled && !anim.running) {
                anim.restart()
            }
            buttonPressedTimer.restart()
        }
    }

    function animIn(){
        animDown.restart();
    }

    function animOut(){
        animUp.restart();
    }


}
