import Qt 4.7

Image {
    id: imgCloud
    source: "qrc:/images/cloud.png"
    smooth: true

    x:fromX;
    y:fromY;

    property int fromY:0;
    property int fromX:0;
    property int animTime:15000;
    property int animDelay: 0;

    SequentialAnimation {
        id: cloudHorizontal
        PropertyAction { target: imgCloud; property: "x"; value: fromX }
        PauseAnimation { duration: animDelay; }
        NumberAnimation {
            loops: Animation.Infinite;
            target:imgCloud; property: "x"; from: fromX; to:fromX+main.height;
                            easing.type: Easing.Linear; duration: animTime }
    }

    SequentialAnimation {
        id: cloudVertical
        PropertyAction { target: imgCloud; property: "y"; value: fromY }
        PauseAnimation { duration: animDelay; }
        NumberAnimation {
            loops: Animation.Infinite;
            target:imgCloud; property: "y"; from: fromY; to:main.height;
                            easing.type: Easing.Linear; duration: animTime }
    }


    function randomX()
    {
        imgCloud.fromX = Math.random()*main.height;
        return imgCloud.fromX;
    }

    function start(started)
    {
        if (started){
            cloudHorizontal.restart();
            cloudVertical.restart();
        }
        else{
            cloudHorizontal.stop();
            cloudVertical.stop();
        }
    }

    function pause(doPause)
    {
        if (doPause){
            cloudHorizontal.pause();
            cloudVertical.pause();
        }
        else {
            cloudHorizontal.resume();
            cloudVertical.resume();
        }
    }
}


