/*
* Copyright (c) 2011 Mobiosis.
*/

import Qt 4.7

//Component {
    Item {
        id: gameItem
        //width: gameMenu.cellWidth; height: gameMenu.cellHeight
        width: gameMenu.width/5;
        height: gameImg.height + /*gameTxt.height + */rankImg.height /*+ 40*/
            //gameMenu.height/4

        property bool selectedItem: false
        property int type

        property alias internalImage: gameImg;

        signal itemSelected()

        function getText(){
            return gameTxt.text
        }

        SequentialAnimation {
            id: toRotateRightAndCenterAnim
            PropertyAnimation { target: rotationId; easing.type: Easing.Linear;
                properties: "angle"; from: 0; to: 180; duration: 300 }
            PropertyAnimation { target: rotationId; easing.type: Easing.Linear;
                properties: "angle"; from: 180; to: 360; duration: 300 }
        }

        function selectItem(doSelect) {
            if (!canPlay) {
                //wrong beep
                console.debug("level is disabled")
                GameEngine.playSound(12)
            }
            else if (!toRotateRightAndCenterAnim.running) {
                console.debug("level is enabled")
                GameEngine.playSound(4)
                if (doSelect) {
//                    GameEngine.playSound(5)
                    //selectionTimer.restart()
                    gameItem.itemSelected()
                    toRotateRightAndCenterAnim.restart()
                }
            }
        }

        Timer {
            id: selectionTimer
            interval: 1000; running: false; repeat: false
            onTriggered: gameItem.itemSelected()
        }

        MouseArea {
            id: mouseArea;
            anchors.fill: parent
            onClicked: {
                selectItem(true)
            }
        }

        onActiveFocusChanged:console.debug("game item active focus is ", activeFocus);

        Keys.onSpacePressed: { selectItem(true) }
        Keys.onSelectPressed: { selectItem(true) }
        Keys.onEnterPressed: { selectItem(true) }
        Keys.onReleased: {
            if (event.key == Qt.Key_Down || event.key == Qt.Key_Up) {
                selectItem(false)
            }
            event.accepted = false
        }

        Column{
            id: column
            anchors.fill: parent

            Image{
                id: gameImg
                source: canPlay? image : "qrc:/images/level_unknown.svg"
                height: gameItem.width
                fillMode: Image.PreserveAspectFit
                anchors.horizontalCenter: parent.horizontalCenter
                transform: Rotation { id:rotationId;
                    origin.x: parent.x+x+gameImg.width/2
                    axis { x: 0; y: 1; z: 0 }}
            }

            Text {
                id: gameTxt
                text: name
                color: "black"
                opacity: 0
                font.family: "Calibri"
                font.pixelSize:  menu.width / 8
                x: (parent.width - width )/ 2
            }
            Image {
                id: rankImg
                source: {
                    if (passed == true) {
                        return result == 1 ? "qrc:/images/rank_cadett.svg" :
                                result == 2 ? "qrc:/images/rank_officer.svg" :
                                result == 3 ? "qrc:/images/rank_officer2.svg" :
                                result == 4 ? "qrc:/images/rank_captain.svg" :
                                                ""
                        }
                    else return ""
                    }
                width: gameItem.width/3*2
                height: gameItem.width/9*2
                anchors.horizontalCenter: parent.horizontalCenter
                //fillMode: Image.PreserveAspectFit
            }
        }
    }
//}

