import Qt 4.7

Item {
    id: indicator
    property string imgPath //path to the basic image
    property string imgPathMin //pathe to the second image (on feature)
    property string imgPathMax //
    property real level //indicator level (0-1)

    property real limitMin: 0.2; //level when image MIN comes on
    property real limitMax: 0.8; //MAX respectively...

    width: 20
    height: 4*width

    Image {
        id: backgroundImage
        source: "qrc:/images/indicator_bg.svg"
        anchors.fill: parent;
    }

    Image {
        id: foregroundImage
        source: "qrc:/images/indicator_fg.svg"
        width: parent.width/2
        height: width*3
        anchors {
            top: parent.top
            horizontalCenter: parent.horizontalCenter
            topMargin: 10
        }
    }

    Rectangle {
        id: bar
        color: "darkgray"
        x: foregroundImage.x
        y: foregroundImage.y

        width: parent.width/2
        height: 3*width*(1-level)

    }

    Image {
        id: icon
        source: chooseImage();
        width: parent.width*2/3
        height: width
        smooth: true
        fillMode: Image.PreserveAspectFit

        anchors{
            bottom: parent.bottom
            horizontalCenter: parent.horizontalCenter
            margins: 10
        }
    }

    SequentialAnimation {
        id: extinctAnim;
        PropertyAction { target: indicator; properties: "opacity"; value: 1 }
        PauseAnimation {duration: 1500;}
        PropertyAnimation{target: indicator; property: "opacity"; to: 0; duration: 1000;}
        //PropertyAction { target: redDot; properties: "opacity"; value: 0 }
    }

function extinct(){
    extinctAnim.restart();
}

function chooseImage(){
    if (imgPathMin.length && level <= limitMin)
        return imgPathMin;
    else if (imgPathMax.length && level >= limitMax)
        return imgPathMax;
    else
        return imgPath;
}
}
