/*
* Copyright (c) 2010 Nokia Corporation.
*/

import Qt 4.7

Item {
    id: menuItem

    property int type
    property bool selectedItem: false
    property bool firstItem;
    property bool lastItem;
    signal itemSelected()

    width:parent.width
    height: textItem.paintedHeight
    anchors {
        left:parent.left
    }

    Image{
        //decoration
        id:decorationTop
        source:hasTop()
        width: parent.width
        //fillMode: Image.PreserveAspectCrop
        anchors {
            horizontalCenter:parent.horizontalCenter
            top: parent.top
        }

        function hasTop(){
            if (position == "top")
                return "qrc:/images/menu_top.svg"
            else
                return ""
        }
    }

    Rectangle{
    color: "white"
    opacity: 0.2
    anchors{
        top: decorationTop.bottom
        bottom: parent.bottom
        left:parent.left
        right:parent.right
        }
    }

    Image{
        //decoration
        id: menuBg
        source:"qrc:/images/menu_bar.svg"
        width: parent.width
        fillMode: Image.PreserveAspectFit
        anchors {
            horizontalCenter:parent.horizontalCenter
            verticalCenter: parent.bottom
        }
    }

    Image{
        //decoration
        source:hasBottom()
        width: parent.width
        //fillMode: Image.PreserveAspectFit
        anchors {
            horizontalCenter:parent.horizontalCenter
            top: parent.bottom
        }

        function hasBottom(){
            if (position == "bottom")
                return "qrc:/images/menu_bottom.svg"
            else
                return ""
        }
    }

    Text {
        id: textItem
        text: name
        color: "white"
        opacity: 1
        font.family: "Calibri"
        font.pixelSize:  menu.width / 8
        x: parent.x+(parent.width - paintedWidth)/ 2
    }

transform: Rotation { id:rotationId; origin.x:width/2; origin.y:height/2; axis { x: 1; y: 0; z: 0 } angle: 0 }
SequentialAnimation {
    id: toRotateRightAndCenterAnim
    PropertyAnimation { target: rotationId; easing.type: Easing.Linear;
        properties: "angle"; from: 0; to: 180; duration: 300 }
    //PropertyAction  { target: menuItem; property: "color"; value:"gray"}
    PropertyAnimation { target: rotationId; easing.type: Easing.Linear;
        properties: "angle"; from: 180; to: 360; duration: 300 }
    //PropertyAction  { target: menuItem; property: "color"; value:"black"}
}



function selectItem(doSelect) {
//    if (!toRotateRightAndCenterAnim.running) {
        GameEngine.playSound(4)
        //toRotateRightAndCenterAnim.restart()
        if (doSelect) {
            GameEngine.fastVibra()
            menuItem.itemSelected()
        }
//    }
}

MouseArea {
    id: mouseArea;
    anchors.fill: parent
    onClicked: {
        selectItem(true)
    }
}

Keys.onSpacePressed: { selectItem(true) }
Keys.onSelectPressed: { selectItem(true) }
Keys.onEnterPressed: { selectItem(true) }
Keys.onReleased: {
    if (event.key == Qt.Key_Down || event.key == Qt.Key_Up) {
        selectItem(false)
    }
    event.accepted = false
}


}




