/*
* Copyright (c) 2010 Nokia Corporation.
*/

import Qt 4.7

import "game.js" as GameScript

Item {
    id: message
    height: main.height / 8
    opacity: 0 // transparent = 0 by default

    property string decoration;

    property string txt
    property int animSpeed

    function showMessage(text,speed) {
        textRect.border.color = "black"
        message.y = 20
        message.opacity = 1
        textRect.radius = 8

        messageText.font.pixelSize = parent.height / 14
        messageText.anchors.horizontalCenter = message.horizontalCenter;

        messageText.wrapMode = Text.NoWrap;

        imgDeco.opacity = 0;

        txt = text
        message.width = messageText.paintedWidth + 20;
        animSpeed = speed
        messageAnim.restart()

    }

    function showWarningMessage(text,speed) {
        textRect.border.width = 0;
        textRect.color = "black"
        message.opacity = 1
        textRect.radius = 0

        messageText.opacity = 1
        messageText.font.pixelSize = parent.height / 14
        messageText.color = "white"
        messageText.anchors.horizontalCenter = message.horizontalCenter;

        messageText.wrapMode = Text.NoWrap;

        txt = text;

        message.width = imgDeco.width+messageText.paintedWidth + 20;

        if (decoration != "")
            imgDeco.opacity = 1;

        //main.width / 5 * 4
        message.x = 60//main.width/2 - width/2
        message.y = main.height - 50

        animSpeed = speed
        textAnim.restart()
    }


    SequentialAnimation {
        id: messageAnim
        PropertyAnimation {
            target: message; properties: "x";
            from: message.width*-1; to: main.width; duration: animSpeed; easing.type: Easing.OutInExpo}
        PropertyAction { target: message; properties: "opacity"; value: 0 }
    }


    SequentialAnimation {
        id: textAnim
        PauseAnimation { duration: animSpeed; }
        PropertyAction { target: message; properties: "opacity"; value: 0 }
    }

    Image{
        id: imgDeco
        source: decoration
        height: parent.height
        width: height
        fillMode: Image.PreserveAspectFit

        anchors {
            left: parent.left
            verticalCenter: parent.verticalCenter
        }
    }

    Rectangle{
        id:textRect
        border.color: "black"
        border.width: 1
        radius: 8
        opacity:0.7
        smooth: true
        color: "black"
        height: parent.height

        anchors {
            left:{return imgDeco.opacity? imgDeco.right: parent.left}
            right:parent.right
            verticalCenter: parent.verticalCenter;
        }
    }

    Text {
        id: messageText
        anchors.fill: textRect
        anchors.margins: 10
        text: txt
        wrapMode: Text.Wrap
        color: "white"
        font.family: "Calibri"
        font.pixelSize:  parent.width / 14
        font.bold: true
        onLinkActivated: {
            GameEngine.openLink(link)
        }
    }
}
