import Qt 4.7

Item {
    //these are normalized vectors with float value <-1:1>
    //use them directly for the steering
    property real vectorX
    property real vectorY

    property real accX:0; //from keys
    property real accY:0; //from keys

    //property real vectorZ //not used for the moment

    property int vmax: 30 //max variation in degrees

    property real rawangleX: 0
    property real angleconstantX

    property real rawangleY: 0
    property real angleconstantY

    property real rawangleZ: 0
    property real angleconstantZ

    property string axisY: "y"; //this is to tell which angle will be chosen for axis Y

    function normalizedX()
    {
        //angles on this axis are -90 +90 so we have to use another axis to recognize full rotation
        var anglecalc = //rawangleZ>0? 180-rawangleX :
                        rawangleX;

        return normalized(anglecalc - angleconstantX + accX, vmax);
    }

    function normalizedY()
    {
        return normalized(rawangleY - angleconstantY + accY, vmax);
    }

    function normalizedZ(){
        return normalized(rawangleZ - angleconstantZ + accY, vmax);
    }

    function normalized(value, absLimit) //value normalized to -1 ... 1
    {
        while (value > 180) value-=360;
        while (value < -180) value+=360;
        var result;

        if (value > absLimit)
            return 1;
        if (value < -absLimit)
            return -1;
        else
            result = value/absLimit;

        if (result < 0.15 && result > -0.15)
            return 0.0;
        else
            return result;
    }

    vectorX: {return normalizedX();}
    vectorY: {
        if (axisY == "y")
            return normalizedY();
        else if (axisY == "z")
            return normalizedZ();
        else return 0.0;
    }

    //vectorZ: normalizedZ();

    onAngleconstantXChanged: {
        console.debug("(constX): ", angleconstantX);
        timerLogSteer.restart()
    }
    onAngleconstantYChanged: {
        console.debug("(constY): ", angleconstantY);
        timerLogSteer.restart()
    }
    onAngleconstantZChanged: {
        console.debug("(constZ): ", angleconstantZ);
        timerLogSteer.restart()
    }

    NumberAnimation {id: deaccX; target: steer; property: "accX"; to: 0; duration: 3000 }
    NumberAnimation {id: deaccY; target: steer; property: "accY"; to: 0; duration: 3000 }

    Timer {
        id: timerLogSteer
        repeat: true
        interval: 500
        onTriggered: {
//            console.debug("x: ", rawangleX, " y: ", rawangleY, " z: ", rawangleZ,
            //console.debug(
//                              " vX: ", vectorX, " vY: ", vectorY);
        }
    }

    function handleKey(key)
    {
        var acctemp = vmax/5;
        if (key == Qt.Key_Left){
            if (accX < vmax){
            accX += acctemp;
            deaccX.restart();
            }
        }
        else if (key == Qt.Key_Right){
            if (accX > -vmax){
            accX -= acctemp;
            deaccX.restart();
            }
        }
        else if (key == Qt.Key_Down){
            if (accY > -vmax){
            accY -= acctemp;
            deaccY.restart();
            }
        }
        else if (key == Qt.Key_Up){
            if (accY < vmax){
            accY += acctemp;
            deaccY.restart();
            }
        }
        //console.debug("acc X = ", accX, " accY = ", accY);
    }
}
