/*
 * Copyright (c) 2011 Nokia Corporation.
 */

import Qt 4.7

Rectangle {
    id: button

    property int buttonId: 0;
    property alias source: image.source
    property alias text: buttonText.text
    property alias mouseAreaScale: mouseArea.scale

    signal btnClicked(int buttonId);

    width: 50; height: 50
    color: "transparent"
    border { width: 2; color: "#555555" }
    radius: 10

    gradient: Gradient {
        GradientStop { position: 0.0; color: "#999999" }
        GradientStop { position: 0.2; color: "#BBBBBB" }
        GradientStop { position: 0.8; color: "#BBBBBB" }
        GradientStop { position: 1.0; color: "#999999" }
    }


    Behavior on scale { NumberAnimation { duration: 50 } }

    Image {
        id: image

        anchors.fill: parent
        smooth: true
    }

    Text {
        id: buttonText;
        anchors.centerIn: parent
        color: "#302020"
        font { bold: true; pixelSize: parent.height * 0.5 }
        smooth: true
    }


    MouseArea {
        id: mouseArea

        anchors.fill: parent
        onClicked: { button.btnClicked(buttonId) }
        onEntered: { button.scale = 0.9 }
        onExited: { button.scale = 1.0 }
    }
}
